Index: sasmodels/models/core_shell_ellipsoid.py
===================================================================
--- sasmodels/models/core_shell_ellipsoid.py	(revision 5111921153c056b59ff03411e4b7b028d238ae26)
+++ sasmodels/models/core_shell_ellipsoid.py	(revision 29172aa52f4fdcefe534e792b14ec43221514fe1)
@@ -1,5 +1,5 @@
 r"""
 This model provides the form factor, $P(q)$, for a core shell ellipsoid (below)
-where the form factor is normalized by the volume of the cylinder.
+where the form factor is normalized by the volume of the outer [CHECK].
 
 .. math::
@@ -7,5 +7,5 @@
     P(q) = scale * \left<f^2\right>/V + background
 
-where the volume $V = (4/3)\pi(r_{maj}r_{min}^2)$ and the averaging $< >$ is
+where the volume $V = (4/3)\pi(R_{major\_outer}R_{minor\_outer}^2)$ and the averaging $< >$ is
 applied over all orientations for 1D.
 
@@ -22,9 +22,9 @@
 
     P(q) = \frac{scale}{V}\int_0^1
-        \left|F(q,r_{min},r_{max},\alpha)\right|^2d\alpha + background
+        \left|F(q,r_{minor\_core},r_{major\_core},\alpha) + F(q,r_{major\_outer},r_{major\_outer},\alpha)\right|^2d\alpha + background
 
-    \left|F(q,r_{min},r_{max},\alpha)\right|=V\Delta \rho \cdot (3j_1(u)/u)
+    \left|F(q,r_{minor},r_{major},\alpha)\right|=(4\pi/3)r_{major}r_{minor}^2 \Delta \rho \cdot (3j_1(u)/u)
 
-    u = q\left[ r_{maj}^2\alpha ^2 + r_{min}^2(1-\alpha ^2)\right]^{1/2}
+    u = q\left[ r_{major}^2\alpha ^2 + r_{minor}^2(1-\alpha ^2)\right]^{1/2}
 
 where
@@ -43,4 +43,9 @@
 polar core radius, *equat_shell* = $r_{min}$ (or equatorial outer radius),
 and *polar_shell* = $r_{maj}$ (or polar outer radius).
+
+Note:It is the users' responsibility to ensure that shell radii are larger than 
+the core radii, especially if both are polydisperse, in which case the
+core_shell_ellipsoid_xt model may be much better.
+
 
 .. note::
@@ -77,15 +82,16 @@
     single particle scattering amplitude.
     [Parameters]:
-    equat_core = equatorial radius of core,
-    polar_core = polar radius of core,
-    equat_shell = equatorial radius of shell,
-    polar_shell = polar radius (revolution axis) of shell,
-    core_sld = SLD_core
-    shell_sld = SLD_shell
-    solvent_sld = SLD_solvent
+    equat_core = equatorial radius of core, Rminor_core,
+    polar_core = polar radius of core, Rmajor_core,
+    equat_shell = equatorial radius of shell, Rminor_outer,
+    polar_shell = polar radius of shell, Rmajor_outer,
+    sld_core = scattering length density of core,
+    sld_shell = scattering length density of shell,
+    sld_solvent = scattering length density of solvent,
     background = Incoherent bkg
     scale =scale
     Note:It is the users' responsibility to ensure
-    that shell radii are larger than core radii.
+    that shell radii are larger than core radii,
+    especially if both are polydisperse.
     oblate: polar radius < equatorial radius
     prolate :  polar radius > equatorial radius
@@ -97,11 +103,11 @@
 #             ["name", "units", default, [lower, upper], "type", "description"],
 parameters = [
-    ["equat_core",  "Ang",      200,   [0, inf],    "volume",      "Equatorial radius of core"],
-    ["polar_core",  "Ang",       10,   [0, inf],    "volume",      "Polar radius of core"],
-    ["equat_shell", "Ang",      250,   [0, inf],    "volume",      "Equatorial radius of shell"],
-    ["polar_shell", "Ang",       30,   [0, inf],    "volume",      "Polar radius of shell"],
-    ["core_sld",    "1e-6/Ang^2", 2,   [-inf, inf], "",            "Core scattering length density"],
-    ["shell_sld",   "1e-6/Ang^2", 1,   [-inf, inf], "",            "Shell scattering length density"],
-    ["solvent_sld", "1e-6/Ang^2", 6.3, [-inf, inf], "",            "Solvent scattering length density"],
+    ["equat_core",  "Ang",      200,   [0, inf],    "volume",      "Equatorial radius of core, Rminor_core "],
+    ["polar_core",  "Ang",       10,   [0, inf],    "volume",      "Polar radius of core, Rmajor_core"],
+    ["equat_shell", "Ang",      250,   [0, inf],    "volume",      "Equatorial radius of shell, Rminor_outer "],
+    ["polar_shell", "Ang",       30,   [0, inf],    "volume",      "Polar radius of shell, Rmajor_outer"],
+    ["sld_core",    "1e-6/Ang^2", 2,   [-inf, inf], "sld",            "Core scattering length density"],
+    ["sld_shell",   "1e-6/Ang^2", 1,   [-inf, inf], "sld",            "Shell scattering length density"],
+    ["sld_solvent", "1e-6/Ang^2", 6.3, [-inf, inf], "sld",            "Solvent scattering length density"],
     ["theta",       "degrees",    0,   [-inf, inf], "orientation", "Oblate orientation wrt incoming beam"],
     ["phi",         "degrees",    0,   [-inf, inf], "orientation", "Oblate orientation in the plane of the detector"],
@@ -116,7 +122,7 @@
             equat_shell=250.0,
             polar_shell=30.0,
-            core_sld=2.0,
-            shell_sld=1.0,
-            solvent_sld=6.3,
+            sld_core=2.0,
+            sld_shell=1.0,
+            sld_solvent=6.3,
             theta=0,
             phi=0)
@@ -124,7 +130,8 @@
 oldname = 'CoreShellEllipsoidModel'
 
-oldpars = dict(core_sld='sld_core',
-               shell_sld='sld_shell',
-               solvent_sld='sld_solvent',
+oldpars = dict(equat_core='equat_core',polar_core='polar_core',equat_shell='equat_shell',polar_shell='polar_shell',
+               sld_core='sld_core',
+               sld_shell='sld_shell',
+               sld_solvent='sld_solvent',
                theta='axis_theta',
                phi='axis_phi')
@@ -141,7 +148,7 @@
       'equat_shell': 250.0,
       'polar_shell': 30.0,
-      'core_sld': 2.0,
-      'shell_sld': 1.0,
-      'solvent_sld': 6.3,
+      'sld_core': 2.0,
+      'sld_shell': 1.0,
+      'sld_solvent': 6.3,
       'background': 0.001,
       'scale': 1.0,
@@ -155,7 +162,7 @@
       'equat_shell': 54.0,
       'polar_shell': 3.0,
-      'core_sld': 20.0,
-      'shell_sld': 10.0,
-      'solvent_sld': 6.0,
+      'sld_core': 20.0,
+      'sld_shell': 10.0,
+      'sld_solvent': 6.0,
       'background': 0.0,
       'scale': 1.0,
@@ -168,7 +175,7 @@
       'equat_shell': 54.0,
       'polar_shell': 3.0,
-      'core_sld': 20.0,
-      'shell_sld': 10.0,
-      'solvent_sld': 6.0,
+      'sld_core': 20.0,
+      'sld_shell': 10.0,
+      'sld_solvent': 6.0,
       'background': 0.01,
       'scale': 0.01,
Index: sasmodels/models/core_shell_ellipsoid_xt.py
===================================================================
--- sasmodels/models/core_shell_ellipsoid_xt.py	(revision 5111921153c056b59ff03411e4b7b028d238ae26)
+++ sasmodels/models/core_shell_ellipsoid_xt.py	(revision 29172aa52f4fdcefe534e792b14ec43221514fe1)
@@ -1,9 +1,9 @@
 r"""
-An alternative version of $P(q)$ for the core-shell ellipsoid
-(see CoreShellEllipsoidModel), having as parameters the core axial ratio X
-and a shell thickness, which are more often what we would like to determine.
+An alternative version of $P(q)$ for the core_shell_ellipsoid
+having as parameters the core axial ratio X and a shell thickness, 
+which are more often what we would like to determine.
 
 This model is also better behaved when polydispersity is applied than the four
-independent radii in CoreShellEllipsoidModel.
+independent radii in core_shell_ellipsoid model.
 
 Definition
@@ -52,5 +52,5 @@
 ----------
 
-R K Heenan, *Private communication*
+R K Heenan, 2015, reparametrised the core_shell_ellipsoid model
 
 """
@@ -69,10 +69,10 @@
         [Parameters]:
         equat_core = equatorial radius of core,
-        x_core = polar radius of core,
+        x_core = ratio of core polar/equatorial radii,
         t_shell = equatorial radius of outer surface,
-        x_polar_shell = polar radius (revolution axis) of outer surface
-        core_sld = SLD_core
-        shell_sld = SLD_shell
-        solvent_sld = SLD_solvent
+        x_polar_shell = ratio of polar shell thickness to equatorial shell thickness,
+        sld_core = SLD_core
+        sld_shell = SLD_shell
+        sld_solvent = SLD_solvent
         background = Incoherent bkg
         scale =scale
@@ -92,7 +92,7 @@
     ["t_shell",       "Ang",       30,   [0, inf],    "volume",      "Equatorial radius of shell"],
     ["x_polar_shell", "",           1,   [0, inf],    "volume",      "Polar radius of shell"],
-    ["core_sld",      "1e-6/Ang^2", 2,   [-inf, inf], "",            "Core scattering length density"],
-    ["shell_sld",     "1e-6/Ang^2", 1,   [-inf, inf], "",            "Shell scattering length density"],
-    ["solvent_sld",   "1e-6/Ang^2", 6.3, [-inf, inf], "",            "Solvent scattering length density"],
+    ["sld_core",      "1e-6/Ang^2", 2,   [-inf, inf], "",            "Core scattering length density"],
+    ["sld_shell",     "1e-6/Ang^2", 1,   [-inf, inf], "",            "Shell scattering length density"],
+    ["sld_solvent",   "1e-6/Ang^2", 6.3, [-inf, inf], "",            "Solvent scattering length density"],
     ["theta",         "degrees",    0,   [-inf, inf], "orientation", "Oblate orientation wrt incoming beam"],
     ["phi",           "degrees",    0,   [-inf, inf], "orientation", "Oblate orientation in the plane of the detector"],
@@ -108,7 +108,7 @@
             t_shell=30.0,
             x_polar_shell=1.0,
-            core_sld=2.0,
-            shell_sld=1.0,
-            solvent_sld=6.3,
+            sld_core=2.0,
+            sld_shell=1.0,
+            sld_solvent=6.3,
             theta=0,
             phi=0)
@@ -119,7 +119,7 @@
                x_core='X_core',
                t_shell='T_shell',
-               core_sld='sld_core',
-               shell_sld='sld_shell',
-               solvent_sld='sld_solvent',
+               sld_core='sld_core',
+               sld_shell='sld_shell',
+               sld_solvent='sld_solvent',
                theta='axis_theta',
                phi='axis_phi')
@@ -136,7 +136,7 @@
       't_shell': 50.0,
       'x_polar_shell': 0.2,
-      'core_sld': 2.0,
-      'shell_sld': 1.0,
-      'solvent_sld': 6.3,
+      'sld_core': 2.0,
+      'sld_shell': 1.0,
+      'sld_solvent': 6.3,
       'background': 0.001,
       'scale': 1.0,
@@ -150,7 +150,7 @@
       't_shell': 54.0,
       'x_polar_shell': 3.0,
-      'core_sld': 20.0,
-      'shell_sld': 10.0,
-      'solvent_sld': 6.0,
+      'sld_core': 20.0,
+      'sld_shell': 10.0,
+      'sld_solvent': 6.0,
       'background': 0.0,
       'scale': 1.0,
@@ -163,7 +163,7 @@
       't_shell': 54.0,
       'x_polar_shell': 3.0,
-      'core_sld': 20.0,
-      'shell_sld': 10.0,
-      'solvent_sld': 6.0,
+      'sld_core': 20.0,
+      'sld_shell': 10.0,
+      'sld_solvent': 6.0,
       'background': 0.01,
       'scale': 0.01,
Index: sasmodels/models/hardsphere.py
===================================================================
--- sasmodels/models/hardsphere.py	(revision 3bcd03d7e1d8d4938d30f17bf360b83417139376)
+++ sasmodels/models/hardsphere.py	(revision e98c1e008cb289d6be876cc1dfb5c76efa378204)
@@ -58,4 +58,5 @@
 category = "structure-factor"
 structure_factor = True
+single = False
 
 #             ["name", "units", default, [lower, upper], "type","description"],
Index: sasmodels/models/lamellar.py
===================================================================
--- sasmodels/models/lamellar.py	(revision aa2edb2b2fb550caed0506dcf63bc7eac7e1779a)
+++ sasmodels/models/lamellar.py	(revision 7c391dd12853b2e9403ba35b776d89aeb6838937)
@@ -5,9 +5,9 @@
 ----------
 
-The scattering intensity $I(q)$ is
+The scattering intensity $I(q)$ for dilute, randomly oriented, "infinitely large" sheets or lamellae is
 
 .. math::
 
-    I(q) = \frac{2\pi P(q)}{\delta q^2}
+    I(q) = scale*\frac{2\pi P(q)}{q^2\delta }
 
 
@@ -16,8 +16,12 @@
 .. math::
 
-    P(q) = \frac{2\Delta\rho^2}{q^2}(1-cos(q\delta))
+   P(q) = \frac{2\Delta\rho^2}{q^2}(1-cos(q\delta)) = \frac{4\Delta\rho^2}{q^2}sin^2(\frac{q\delta}{2})
 
+where $\delta$ is the total layer thickness and $\Delta\rho$ is the scattering length density difference.
 
-where $\delta$ is the bilayer thickness.
+This is the limiting form for a spherical shell of infinitely large radius. Note that the division by $\delta$
+means that $scale$ in sasview is the volume fraction of sheet, $\phi = S\delta$ where $S$ is the area of 
+sheet per unit volume. $S$ is half the Porod surface area per unit volume of a thicker layer (as that would 
+include both faces of the sheet).
 
 The 2D scattering intensity is calculated in the same way as 1D, where
@@ -56,14 +60,11 @@
 
 #             ["name", "units", default, [lower, upper], "type","description"],
-parameters = [["sld", "1e-6/Ang^2", 1, [-inf, inf], "",
-               "Layer scattering length density" ],
-              ["solvent_sld", "1e-6/Ang^2", 6, [-inf, inf], "",
-               "Solvent scattering length density" ],
-              ["thickness", "Ang", 50, [0, inf], "volume","Bilayer thickness" ],
+parameters = [ ["thickness", "Ang", 50, [0, inf], "volume","total layer thickness" ],
+               ["sld", "1e-6/Ang^2", 1, [-inf, inf], "","Layer scattering length density" ],
+               ["sld_solvent", "1e-6/Ang^2", 6, [-inf, inf], "","Solvent scattering length density" ],
              ]
 
-
 # No volume normalization despite having a volume parameter
-# This should perhaps be volume normalized?
+# This should perhaps be volume normalized? - it is!
 form_volume = """
     return 1.0;
@@ -71,5 +72,5 @@
 
 Iq = """
-    const double sub = sld - solvent_sld;
+    const double sub = sld - sld_solvent;
     const double qsq = q*q;
     // Original expression
@@ -89,11 +90,11 @@
 
 demo = dict(scale=1, background=0,
-            sld=6, solvent_sld=1,
+            sld=6, sld_solvent=1,
             thickness=40,
             thickness_pd=0.2, thickness_pd_n=40)
 oldname = 'LamellarModel'
-oldpars = dict(sld='sld_bi', solvent_sld='sld_sol', thickness='bi_thick')
+oldpars = dict(sld='sld_bi', sld_solvent='sld_sol', thickness='bi_thick')
 tests = [
-        [ {'scale': 1.0, 'background' : 0.0, 'thickness' : 50.0, 'sld' : 1.0,'solvent_sld' : 6.3, 'thickness_pd' : 0.0, 
+        [ {'scale': 1.0, 'background' : 0.0, 'thickness' : 50.0, 'sld' : 1.0,'sld_solvent' : 6.3, 'thickness_pd' : 0.0, 
            }, [0.001], [882289.54309]]
         ]
Index: sasmodels/models/lamellar_hg.py
===================================================================
--- sasmodels/models/lamellar_hg.py	(revision 52a3db3cb286d26bfdebb3ea92ad54cd92a07c7f)
+++ sasmodels/models/lamellar_hg.py	(revision 52a3db3cb286d26bfdebb3ea92ad54cd92a07c7f)
@@ -0,0 +1,122 @@
+# Note: model title and parameter table are inserted automatically
+r"""
+This model provides the scattering intensity, $I(q)$, for a lyotropic lamellar
+phase where a random distribution in solution are assumed. The SLD of the head
+region is taken to be different from the SLD of the tail region.
+
+Definition
+----------
+
+The scattering intensity $I(q)$ is
+
+.. math::
+
+   I(q) = 2\pi\frac{\text{scale}}{2(\delta_H + \delta_T)}  P(q) \frac{1}{q^2}
+
+The form factor $P(q)$ is
+
+.. math::
+
+    P(q) = \frac{4}{q^2}
+        \left\lbrace
+            \Delta \rho_H
+            \left[\sin[q(\delta_H + \delta_T)\ - \sin(q\delta_T)\right]
+            + \Delta\rho_T\sin(q\delta_T)
+        \right\rbrace^2
+
+where $\delta_T$ is *tail_length*, $\delta_H$ is *head_length*,
+$\Delta\rho_H$ is the head contrast (*sld_head* $-$ *sld_solvent*),
+and $\Delta\rho_T$ is tail contrast (*sld* $-$ *sld_solvent*).
+
+The total thickness of the lamellar sheet is $\delta_H$ + $\delta_T$ + $\delta_T$ + $\delta_H$.
+Note that in a non aqueous solvent the chemical "head" group may be the 
+"Tail region" and vice-versa.
+
+The 2D scattering intensity is calculated in the same way as 1D, where
+the $q$ vector is defined as
+
+.. math::
+
+    q = \sqrt{q_x^2 + q_y^2}
+
+
+References
+----------
+
+F Nallet, R Laversanne, and D Roux, J. Phys. II France, 3, (1993) 487-502
+
+also in J. Phys. Chem. B, 105, (2001) 11081-11088
+
+*2014/04/17 - Description reviewed by S King and P Butler.*
+"""
+
+from numpy import inf
+
+name = "lamellar_hg"
+title = "Random lamellar phase with Head and Tail Groups"
+description = """\
+    [Random lamellar phase with Head and Tail Groups]
+        I(q)= 2*pi*P(q)/(2(H+T)*q^(2)), where
+        P(q)= see manual
+        layer thickness =(H+T+T+H) = 2(Head+Tail)
+        sld = Tail scattering length density
+        sld_head = Head scattering length density
+        sld_solvent = solvent scattering length density
+        background = incoherent background
+        scale = scale factor
+"""
+category = "shape:lamellae"
+
+# pylint: disable=bad-whitespace, line-too-long
+#             ["name", "units", default, [lower, upper], "type","description"],
+parameters = [["tail_length", "Ang",       15,   [0, inf],  "volume",  "Tail thickness ( total = H+T+T+H)"],
+              ["head_length", "Ang",       10,   [0, inf],  "volume",  "Head thickness"],
+              ["sld",         "1e-6/Ang^2", 0.4, [-inf,inf], "",       "Tail scattering length density"],
+              ["sld_head",    "1e-6/Ang^2", 3.0, [-inf,inf], "",       "Head scattering length density"],
+              ["sld_solvent", "1e-6/Ang^2", 6,   [-inf,inf], "",       "Solvent scattering length density"]]
+# pylint: enable=bad-whitespace, line-too-long
+
+# No volume normalization despite having a volume parameter
+# This should perhaps be volume normalized?
+form_volume = """
+    return 1.0;
+    """
+
+Iq = """
+    const double qsq = q*q;
+    const double drh = sld_head - sld_solvent;
+    const double drt = sld - sld_solvent;    //correction 13FEB06 by L.Porcar
+    const double qT = q*tail_length;
+    double Pq, inten;
+    Pq = drh*(sin(q*(head_length+tail_length))-sin(qT)) + drt*sin(qT);
+    Pq *= Pq;
+    Pq *= 4.0/(qsq);
+
+    inten = 2.0e-4*M_PI*Pq/qsq;
+
+    // normalize by the bilayer thickness
+    inten /= 2.0*(head_length+tail_length);
+
+    return inten;
+    """
+
+Iqxy = """
+    return Iq(sqrt(qx*qx+qy*qy), IQ_PARAMETERS);
+    """
+
+# ER defaults to 0.0
+# VR defaults to 1.0
+
+demo = dict(scale=1, background=0,
+            tail_length=15, head_length=10,
+            sld=0.4, sld_head=3.0, sld_solvent=6.0,
+            tail_length_pd=0.2, tail_length_pd_n=40,
+            head_length_pd=0.01, head_length_pd_n=40)
+
+oldname = 'LamellarFFHGModel'
+oldpars = dict(head_length='h_thickness', tail_length='t_length',
+               sld='sld_tail', sld_head='sld_head', sld_solvent='sld_solvent')
+#
+tests = [[{'scale': 1.0, 'background': 0.0, 'tail_length': 15.0, 'head_length': 10.0,
+           'sld': 0.4, 'sld_head': 3.0, 'sld_solvent': 6.0}, [0.001], [653143.9209]]]
+# ADDED by: RKH  ON: 18Mar2016  converted from sasview previously, now renaming everything & sorting the docs
Index: sasmodels/models/lamellar_hg_stack_caille.py
===================================================================
--- sasmodels/models/lamellar_hg_stack_caille.py	(revision 6ab4ed8677894e77dfd90dc3fdd5bdac2df2eff8)
+++ sasmodels/models/lamellar_hg_stack_caille.py	(revision 6ab4ed8677894e77dfd90dc3fdd5bdac2df2eff8)
@@ -0,0 +1,151 @@
+# Note: model title and parameter table are inserted automatically
+r"""
+This model provides the scattering intensity, $I(q) = P(q)S(q)$, for a lamellar
+phase where a random distribution in solution are assumed. Here a Caille $S(q)$
+is used for the lamellar stacks.
+
+The scattering intensity $I(q)$ is
+
+.. math::
+
+    I(q) = 2 \pi \frac{P(q)S(q)}{q^2\delta }
+
+
+The form factor $P(q)$ is
+
+.. math::
+
+        P(q) = \frac{4}{q^2}\big\{
+        \Delta\rho_H \left[\sin[q(\delta_H + \delta_T)] - \sin(q\delta_T)\right]
+            + \Delta\rho_T\sin(q\delta_T)\big\}^2
+
+and the structure factor $S(q)$ is
+
+.. math::
+
+    S(q) = 1 + 2 \sum_1^{N-1}\left(1-\frac{n}{N}\right)
+        \cos(qdn)\exp\left(-\frac{2q^2d^2\alpha(n)}{2}\right)
+
+where
+
+.. math::
+    :nowrap:
+
+    \begin{align*}
+    \alpha(n) &= \frac{\eta_{cp}}{4\pi^2} \left(\ln(\pi n)+\gamma_E\right)
+              &&  \\
+    \gamma_E  &= 0.5772156649
+              && \text{Euler's constant} \\
+    \eta_{cp} &= \frac{q_o^2k_B T}{8\pi\sqrt{K\overline{B}}}
+              && \text{Caille constant}
+    \end{align*}
+
+
+$\delta_T$ is the tail length (or *tail_length*), $\delta_H$ is the head
+thickness (or *head_length*), $\Delta\rho_H$ is SLD(headgroup) - SLD(solvent),
+and $\Delta\rho_T$ is SLD(tail) - SLD(headgroup). Here $d$ is (repeat) spacing,
+$K$ is smectic bending elasticity, $B$ is compression modulus, and $N$ is the
+number of lamellar plates (*Nlayers*).
+
+NB: **When the Caille parameter is greater than approximately 0.8 to 1.0, the
+assumptions of the model are incorrect.**  And due to a complication of the
+model function, users are responsible for making sure that all the assumptions
+are handled accurately (see the original reference below for more details).
+
+Non-integer numbers of stacks are calculated as a linear combination of
+results for the next lower and higher values.
+
+Be aware that the computations may be very slow.
+
+The 2D scattering intensity is calculated in the same way as 1D, where
+the $q$ vector is defined as
+
+.. math::
+
+    q = \sqrt{q_x^2 + q_y^2}
+
+
+References
+----------
+
+F Nallet, R Laversanne, and D Roux, J. Phys. II France, 3, (1993) 487-502
+
+also in J. Phys. Chem. B, 105, (2001) 11081-11088
+"""
+from numpy import inf
+
+name = "lamellar_hg_stack_caille"
+title = "Random lamellar head/tail/tail/head sheet with Caille structure factor"
+description = """\
+    [Random lamellar phase with Caille  structure factor]
+        randomly oriented stacks of infinite sheets
+        with Caille S(Q), having polydisperse spacing.
+        layer thickness =(H+T+T+H) = 2(Head+Tail)
+        sld = Tail scattering length density
+        sld_head = Head scattering length density
+        sld_solvent = solvent scattering length density
+        background = incoherent background
+        scale = scale factor
+"""
+category = "shape:lamellae"
+
+single = False
+parameters = [
+    #   [ "name", "units", default, [lower, upper], "type",
+    #     "description" ],
+    ["tail_length", "Ang", 10, [0, inf], "volume",
+     "Tail thickness"],
+    ["head_length", "Ang", 2, [0, inf], "volume",
+     "head thickness"],
+    ["Nlayers", "", 30, [0, inf], "",
+     "Number of layers"],
+    ["spacing", "Ang", 40., [0.0, inf], "volume",
+     "d-spacing of Caille S(Q)"],
+    ["Caille_parameter", "", 0.001, [0.0, 0.8], "",
+     "Caille parameter"],
+    ["sld", "1e-6/Ang^2", 0.4, [-inf, inf], "",
+     "Tail scattering length density"],
+    ["sld_head", "1e-6/Ang^2", 2.0, [-inf, inf], "",
+     "Head scattering length density"],
+    ["sld_solvent", "1e-6/Ang^2", 6, [-inf, inf], "",
+     "Solvent scattering length density"],
+    ]
+
+source = ["lamellar_hg_stack_caille_kernel.c"]
+
+# No volume normalization despite having a volume parameter
+# This should perhaps be volume normalized?
+form_volume = """
+    return 1.0;
+    """
+
+Iqxy = """
+    return Iq(sqrt(qx*qx+qy*qy), IQ_PARAMETERS);
+    """
+
+# ER defaults to 0.0
+# VR defaults to 1.0
+
+demo = dict(
+    scale=1, background=0,
+    Nlayers=20, spacing=200., Caille_parameter=0.05,
+    tail_length=15, head_length=10,
+    #sld=-1, sld_head=4.0, sld_solvent=6.0,
+    sld=-1, sld_head=4.1, sld_solvent=6.0,
+    tail_length_pd=0.1, tail_length_pd_n=20,
+    head_length_pd=0.05, head_length_pd_n=30,
+    spacing_pd=0.2, spacing_pd_n=40,
+    )
+
+oldname = 'LamellarPSHGModel'
+
+oldpars = dict(
+    tail_length='deltaT', head_length='deltaH', Nlayers='n_plates',
+    Caille_parameter='caille', sld='sld_tail', sld_head='sld_head',
+    sld_solvent='sld_solvent')
+#
+tests = [[{'scale': 1.0, 'background': 0.0, 'tail_length': 10.0, 'head_length': 2.0,
+           'Nlayers': 30.0, 'spacing': 40., 'Caille_parameter': 0.001, 'sld': 0.4,
+           'sld_head': 2.0, 'sld_solvent': 6.0, 'tail_length_pd': 0.0,
+           'head_length_pd': 0.0, 'spacing_pd': 0.0}, [0.001], [6838238.571488]]]
+# ADDED by: RKH  ON: 18Mar2016  converted from sasview previously, now renaming everything & sorting the docs
Index: sasmodels/models/lamellar_hg_stack_caille_kernel.c
===================================================================
--- sasmodels/models/lamellar_hg_stack_caille_kernel.c	(revision 6ab4ed8677894e77dfd90dc3fdd5bdac2df2eff8)
+++ sasmodels/models/lamellar_hg_stack_caille_kernel.c	(revision 6ab4ed8677894e77dfd90dc3fdd5bdac2df2eff8)
@@ -0,0 +1,75 @@
+/*	LamellarCailleHG kernel - allows for name changes of passed parameters ...
+    Maths identical to LamellarCaille apart from the line for P(Q)
+*/
+
+double Iq(double qval,
+      double tail_length,
+      double head_length,
+      double Nlayers, 
+      double dd,
+      double Cp,
+      double tail_sld,
+      double head_sld,
+      double solvent_sld);
+
+double Iq(double qval,
+      double tail_length,
+      double head_length,
+      double Nlayers, 
+      double dd,
+      double Cp,
+      double tail_sld,
+      double head_sld,
+      double solvent_sld)
+{
+  double NN;   //local variables of coefficient wave
+  double inten,Pq,Sq,alpha,temp,t2;
+  //double dQ, dQDefault, t1, t3;
+  int ii,NNint;
+  // from wikipedia 0.577215664901532860606512090082402431042159335
+  const double Euler = 0.577215664901533;   // Euler's constant, increased sig figs for new models Feb 2015
+  //dQDefault = 0.0;    //[=] 1/A, q-resolution, default value
+  //dQ = dQDefault; // REMOVED UNUSED dQ calculations for new models Feb 2015
+
+  NN = trunc(Nlayers);    //be sure that NN is an integer
+  
+  Pq = (head_sld-solvent_sld)*(sin(qval*(head_length+tail_length))-sin(qval*tail_length)) +
+              (tail_sld-solvent_sld)*sin(qval*tail_length);
+  Pq *= Pq;
+  Pq *= 4.0/(qval*qval);
+
+  NNint = (int)NN;    //cast to an integer for the loop
+  ii=0;
+  Sq = 0.0;
+  for(ii=1;ii<=(NNint-1);ii+=1) {
+
+    //fii = (double)ii;   //do I really need to do this? - unused variable, removed 18Feb2015
+
+    temp = 0.0;
+    alpha = Cp/4.0/M_PI/M_PI*(log(M_PI*ii) + Euler);
+    //t1 = 2.0*dQ*dQ*dd*dd*alpha;
+    t2 = 2.0*qval*qval*dd*dd*alpha;
+    //t3 = dQ*dQ*dd*dd*ii*ii;
+
+    temp = 1.0-ii/NN;
+    //temp *= cos(dd*qval*ii/(1.0+t1));
+    temp *= cos(dd*qval*ii);
+    //if (temp < 0) printf("q=%g: ii=%d, cos(dd*q*ii)=cos(%g) < 0\n",qval,ii,dd*qval*ii);
+    //temp *= exp(-1.0*(t2 + t3)/(2.0*(1.0+t1)) );
+    temp *= exp(-t2/2.0 );
+    //temp /= sqrt(1.0+t1);
+
+    Sq += temp;
+  }
+
+  Sq *= 2.0;
+  Sq += 1.0;
+
+  //if (Sq < 0) printf("q=%g: S(q) =%g\n", qval, Sq);
+
+  inten = 2.0*M_PI*Pq*Sq/(dd*qval*qval);
+
+  inten *= 1.0e-04;   // 1/A to 1/cm
+  return(inten);
+}
+
Index: sasmodels/models/lamellar_stack_caille.py
===================================================================
--- sasmodels/models/lamellar_stack_caille.py	(revision 6ab4ed8677894e77dfd90dc3fdd5bdac2df2eff8)
+++ sasmodels/models/lamellar_stack_caille.py	(revision 6ab4ed8677894e77dfd90dc3fdd5bdac2df2eff8)
@@ -0,0 +1,130 @@
+r"""
+This model provides the scattering intensity, $I(q) = P(q) S(q)$, for a
+lamellar phase where a random distribution in solution are assumed.
+Here a Caille $S(q)$ is used for the lamellar stacks.
+
+Definition
+----------
+
+The scattering intensity $I(q)$ is
+
+.. math::
+
+    I(q) = 2\pi \frac{P(q)S(q)}{q^2\delta }
+
+The form factor is
+
+.. math::
+
+    P(q) = \frac{2\Delta\rho^2}{q^2}\left(1-\cos q\delta \right)
+
+and the structure factor is
+
+.. math::
+
+    S(q) = 1 + 2 \sum_1^{N-1}\left(1-\frac{n}{N}\right)
+           \cos(qdn)\exp\left(-\frac{2q^2d^2\alpha(n)}{2}\right)
+
+where
+
+.. math::
+    :nowrap:
+
+    \begin{align*}
+    \alpha(n) &= \frac{\eta_{cp}}{4\pi^2} \left(\ln(\pi n)+\gamma_E\right)
+              && \\
+    \gamma_E  &= 0.5772156649
+              && \text{Euler's constant} \\
+    \eta_{cp} &= \frac{q_o^2k_B T}{8\pi\sqrt{K\overline{B}}}
+              && \text{Caille constant}
+    \end{align*}
+
+Here $d$ = (repeat) spacing, $\delta$ = bilayer thickness,
+the contrast $\Delta\rho$ = SLD(headgroup) - SLD(solvent),
+$K$ = smectic bending elasticity, $B$ = compression modulus, and
+$N$ = number of lamellar plates (*n_plates*).
+
+NB: **When the Caille parameter is greater than approximately 0.8 to 1.0, the
+assumptions of the model are incorrect.** And due to a complication of the
+model function, users are responsible for making sure that all the assumptions
+are handled accurately (see the original reference below for more details).
+
+Non-integer numbers of stacks are calculated as a linear combination of
+results for the next lower and higher values.
+
+The 2D scattering intensity is calculated in the same way as 1D, where the
+$q$ vector is defined as
+
+.. math::
+
+    q = \sqrt{q_x^2 + q_y^2}
+
+
+References
+----------
+
+F Nallet, R Laversanne, and D Roux, J. Phys. II France, 3, (1993) 487-502
+
+also in J. Phys. Chem. B, 105, (2001) 11081-11088
+"""
+from numpy import inf
+
+name = "lamellar_stack_caille"
+title = "Random lamellar sheet with Caille structure factor"
+description = """\
+    [Random lamellar phase with Caille  structure factor]
+    randomly oriented stacks of infinite sheets
+    with Caille S(Q), having polydisperse spacing.
+    sld = sheet scattering length density
+    sld_solvent = solvent scattering length density
+    background = incoherent background
+    scale = scale factor
+"""
+category = "shape:lamellae"
+
+single = False
+# pylint: disable=bad-whitespace, line-too-long
+#             ["name", "units", default, [lower, upper], "type","description"],
+parameters = [
+    ["thickness",        "Ang",      30.0,  [0, inf],   "volume", "sheet thickness"],
+    ["Nlayers",          "",          20,   [0, inf],   "",       "Number of layers"],
+    ["spacing",          "Ang",      400.,  [0.0,inf],  "volume", "d-spacing of Caille S(Q)"],
+    ["Caille_parameter", "1/Ang^2",    0.1, [0.0,0.8],  "",       "Caille parameter"],
+    ["sld",              "1e-6/Ang^2", 6.3, [-inf,inf], "",       "layer scattering length density"],
+    ["sld_solvent",      "1e-6/Ang^2", 1.0, [-inf,inf], "",       "Solvent scattering length density"],
+    ]
+# pylint: enable=bad-whitespace, line-too-long
+
+source = ["lamellar_stack_caille_kernel.c"]
+
+# No volume normalization despite having a volume parameter
+# This should perhaps be volume normalized?
+form_volume = """
+    return 1.0;
+    """
+
+Iqxy = """
+    return Iq(sqrt(qx*qx+qy*qy), IQ_PARAMETERS);
+    """
+
+# ER defaults to 0.0
+# VR defaults to 1.0
+
+demo = dict(scale=1, background=0,
+            thickness=67., Nlayers=3.75, spacing=200.,
+            Caille_parameter=0.268, sld=1.0, sld_solvent=6.34,
+            thickness_pd=0.1, thickness_pd_n=100,
+            spacing_pd=0.05, spacing_pd_n=40)
+
+oldname = 'LamellarPSModel'
+oldpars = dict(thickness='delta', Nlayers='N_plates',
+               Caille_parameter='caille',
+               sld='sld_bi', sld_solvent='sld_sol')
+#
+tests = [
+    [{'scale': 1.0, 'background': 0.0, 'thickness': 30., 'Nlayers': 20.0,
+      'spacing': 400., 'Caille_parameter': 0.1, 'sld': 6.3,
+      'sld_solvent': 1.0, 'thickness_pd': 0.0, 'spacing_pd': 0.0},
+     [0.001], [28895.13397]]
+    ]
+# ADDED by: RKH  ON: 18Mar2016  converted from sasview previously, now renaming everything & sorting the docs
